Index: /contrib/z-push/include/utils.php
===================================================================
--- /contrib/z-push/include/utils.php	(revision 4898)
+++ /contrib/z-push/include/utils.php	(revision 4898)
@@ -0,0 +1,234 @@
+<?php
+
+/***********************************************
+* File      :   utils.php
+* Project   :   Z-Push
+* Descr     :
+*
+* Created   :   03.04.2008
+*
+*  Zarafa Deutschland GmbH, www.zarafaserver.de
+* This file is distributed under GPL v2.
+* Consult LICENSE file for details
+************************************************/
+
+// saves information about folder data for a specific device
+function _saveFolderData($devid, $folders) {
+    if (!is_array($folders) || empty ($folders))
+        return false;
+
+    $unique_folders = array ();
+
+    foreach ($folders as $folder) {
+        if (!isset($folder->type))
+            continue;
+
+        // don't save folder-ids for emails
+        if ($folder->type == SYNC_FOLDER_TYPE_INBOX)
+            continue;
+
+        // no folder from that type    or the default folder
+        if (!array_key_exists($folder->type, $unique_folders) || $folder->parentid == 0) {
+            $unique_folders[$folder->type] = $folder->serverid;
+        }
+    }
+
+    // Treo does initial sync for calendar and contacts too, so we need to fake
+    // these folders if they are not supported by the backend
+    if (!array_key_exists(SYNC_FOLDER_TYPE_APPOINTMENT, $unique_folders))
+        $unique_folders[SYNC_FOLDER_TYPE_APPOINTMENT] = SYNC_FOLDER_TYPE_DUMMY;
+    if (!array_key_exists(SYNC_FOLDER_TYPE_CONTACT, $unique_folders))
+        $unique_folders[SYNC_FOLDER_TYPE_CONTACT] = SYNC_FOLDER_TYPE_DUMMY;
+
+    if (!file_put_contents(BASE_PATH.STATE_DIR."/compat-$devid", serialize($unique_folders))) {
+        debugLog("_saveFolderData: Data could not be saved!");
+    }
+}
+
+// returns information about folder data for a specific device
+function _getFolderID($devid, $class) {
+    $filename = BASE_PATH.STATE_DIR."/compat-$devid";
+
+    if (file_exists($filename)) {
+        $arr = unserialize(file_get_contents($filename));
+
+        if ($class == "Calendar")
+            return $arr[SYNC_FOLDER_TYPE_APPOINTMENT];
+        if ($class == "Contacts")
+            return $arr[SYNC_FOLDER_TYPE_CONTACT];
+
+    }
+
+    return false;
+}
+
+/**
+ * Function which converts a hex entryid to a binary entryid.
+ * @param string @data the hexadecimal string
+ */
+function hex2bin($data) {
+    return pack("H*", $data);
+}
+
+function utf8_to_windows1252($string, $option = "")
+{
+    if (function_exists("iconv")){
+        return @iconv("UTF-8", "Windows-1252" . $option, $string);
+    }else{
+        return utf8_decode($string); // no euro support here
+    }
+}
+
+function windows1252_to_utf8($string, $option = "")
+{
+    if (function_exists("iconv")){
+        return @iconv("Windows-1252", "UTF-8" . $option, $string);
+    }else{
+        return utf8_encode($string); // no euro support here
+    }
+}
+
+function w2u($string) { return windows1252_to_utf8($string); }
+function u2w($string) { return utf8_to_windows1252($string); }
+
+function w2ui($string) { return windows1252_to_utf8($string, "//TRANSLIT"); }
+function u2wi($string) { return utf8_to_windows1252($string, "//TRANSLIT"); }
+
+/**
+ * Truncate an UTF-8 encoded sting correctly
+ *
+ * If it's not possible to truncate properly, an empty string is returned
+ *
+ * @param string $string - the string
+ * @param string $length - position where string should be cut
+ * @return string truncated string
+ */
+function utf8_truncate($string, $length) {
+    if (strlen($string) <= $length)
+        return $string;
+
+    while($length >= 0) {
+        if ((ord($string[$length]) < 0x80) || (ord($string[$length]) >= 0xC0))
+            return substr($string, 0, $length);
+
+        $length--;
+    }
+    return "";
+}
+
+
+/**
+ * Build an address string from the components
+ *
+ * @param string $street - the street
+ * @param string $zip - the zip code
+ * @param string $city - the city
+ * @param string $state - the state
+ * @param string $country - the country
+ * @return string the address string or null
+ */
+function buildAddressString($street, $zip, $city, $state, $country) {
+    $out = "";
+
+    if (isset($country) && $street != "") $out = $country;
+
+    $zcs = "";
+    if (isset($zip) && $zip != "") $zcs = $zip;
+    if (isset($city) && $city != "") $zcs .= (($zcs)?" ":"") . $city;
+    if (isset($state) && $state != "") $zcs .= (($zcs)?" ":"") . $state;
+    if ($zcs) $out = $zcs . "\r\n" . $out;
+
+    if (isset($street) && $street != "") $out = $street . (($out)?"\r\n\r\n". $out: "") ;
+
+    return ($out)?$out:null;
+}
+
+/**
+ * Checks if the PHP-MAPI extension is available and in a requested version
+ *
+ * @param string $version - the version to be checked ("6.30.10-18495", parts or build number)
+ * @return boolean installed version is superior to the checked strin
+ */
+function checkMapiExtVersion($version = "") {
+    // compare build number if requested
+    if (preg_match('/^\d+$/',$version) && strlen > 3) {
+        $vs = preg_split('/-/', phpversion("mapi"));
+        return ($version <= $vs[1]);
+    }
+
+    if (extension_loaded("mapi")){
+        if (version_compare(phpversion("mapi"), $version) == -1){
+            return false;
+        }
+    }
+    else
+        return false;
+
+    return true;
+}
+
+/**
+ * Parses and returns an ecoded vCal-Uid from an
+ * OL compatible GlobalObjectID
+ *
+ * @param string $olUid - an OL compatible GlobalObjectID
+ * @return string the vCal-Uid if available in the olUid, else the original olUid as HEX
+ */
+function getICalUidFromOLUid($olUid){
+    //check if "vCal-Uid" is somewhere in outlookid case-insensitive
+    $icalUid = stristr($olUid, "vCal-Uid");
+    if ($icalUid !== false) {
+        //get the length of the ical id - go back 4 position from where "vCal-Uid" was found
+        $begin = unpack("V", substr($olUid, strlen($icalUid) * (-1) - 4, 4));
+        //remove "vCal-Uid" and packed "1" and use the ical id length
+        return substr($icalUid, 12, ($begin[1] - 13));
+    }
+    return strtoupper(bin2hex($olUid));
+}
+
+/**
+ * Checks the given UID if it is an OL compatible GlobalObjectID
+ * If not, the given UID is encoded inside the GlobalObjectID
+ *
+ * @param string $icalUid - an appointment uid as HEX
+ * @return string an OL compatible GlobalObjectID
+ *
+ */
+function getOLUidFromICalUid($icalUid) {
+    if (strlen($icalUid) <= 64) {
+        $len = 13 + strlen($icalUid);
+        $OLUid = pack("V", $len);
+        $OLUid .= "vCal-Uid";
+        $OLUid .= pack("V", 1);
+        $OLUid .= $icalUid;
+        return hex2bin("040000008200E00074C5B7101A82E0080000000000000000000000000000000000000000". bin2hex($OLUid). "00");
+    }
+    else
+       return hex2bin($icalUid);
+}
+
+/**
+ * Extracts the basedate of the GlobalObjectID and the RecurStartTime
+ *
+ * @param string $goid - OL compatible GlobalObjectID
+ * @param long $recurStartTime - RecurStartTime
+ * @return long basedate
+ *
+ */
+function extractBaseDate($goid, $recurStartTime) {
+    $hexbase = substr(bin2hex($goid), 32, 8);
+    $day = hexdec(substr($hexbase, 6, 2));
+    $month = hexdec(substr($hexbase, 4, 2));
+    $year = hexdec(substr($hexbase, 0, 4));
+
+    if ($day && $month && $year) {
+        $h = $recurStartTime >> 12;
+        $m = ($recurStartTime - $h * 4096) >> 6;
+        $s = $recurStartTime - $h * 4096 - $m * 64;
+
+        return gmmktime($h, $m, $s, $month, $day, $year);
+    }
+    else
+        return false;
+}
+?>
Index: /contrib/z-push/include/z_ical.php
===================================================================
--- /contrib/z-push/include/z_ical.php	(revision 4898)
+++ /contrib/z-push/include/z_ical.php	(revision 4898)
@@ -0,0 +1,171 @@
+<?php
+/***********************************************
+* File      :   z_ical.php
+* Project   :   Z-Push
+* Descr     :
+*
+* Created   :   01.12.2008
+*
+* Zarafa Deutschland GmbH, www.zarafaserver.de
+* This file is distributed under GPL v2.
+* Consult LICENSE file for details
+************************************************/
+
+class ZPush_ical{
+    function ZPush_ical($store){
+        $this->_store = $store;
+    }
+
+    /*
+    * Function reads calendar part and puts mapi properties into an array.
+    */
+    function extractProps($ical, &$mapiprops) {
+        //mapping between partstat in ical and MAPI Meeting Response classes as well as icons
+        $aClassMap = array(
+            "ACCEPTED"          => array("class" => "IPM.Schedule.Meeting.Resp.Pos", "icon" => 0x405),
+            "DECLINED"          => array("class" => "IPM.Schedule.Meeting.Resp.Neg", "icon" => 0x406),
+            "TENTATIVE"         => array("class" => "IPM.Schedule.Meeting.Resp.Tent", "icon" => 0x407),
+            "NEEDS-ACTION"      => array("class" => "IPM.Schedule.Meeting.Request", "icon" => 0x404), //iphone
+            "REQ-PARTICIPANT"   => array("class" => "IPM.Schedule.Meeting.Request", "icon" => 0x404), //nokia
+        );
+
+        $aical = array_map("rtrim", preg_split("/[\n]/", $ical));
+        $elemcount = count($aical);
+        $i=0;
+        $nextline = $aical[0];
+        //last element is empty
+        while ($i < $elemcount - 1) {
+            $line = $nextline;
+            //if a line starts with a space or a tab it belongs to the previous line
+            $nextline = $aical[$i+1];
+            if (strlen($nextline) == 0) {
+                $i++;
+                continue;
+            }
+
+            while ($nextline{0} == " " || $nextline{0} == "\t") {
+                $line .= substr($nextline, 1);
+                $nextline = $aical[++$i + 1];
+            }
+            switch (strtoupper($line)) {
+                case "BEGIN:VCALENDAR":
+                case "BEGIN:VEVENT":
+                case "END:VEVENT":
+                case "END:VCALENDAR":
+                    break;
+                default:
+                    unset ($field, $data, $prop_pos, $property);
+                    if (ereg ("([^:]+):(.*)", $line, $line)){
+                        $field = $line[1];
+                        $data = $line[2];
+                        $property = $field;
+                        $prop_pos = strpos($property,';');
+                        if ($prop_pos !== false) $property = substr($property, 0, $prop_pos);
+                        $property = strtoupper($property);
+
+                        switch ($property) {
+                            case 'DTSTART':
+                                $data = $this->getTimestampFromStreamerDate($data);
+                                $namedStartTime = GetPropIDFromString($this->_store, "PT_SYSTIME:{00062002-0000-0000-C000-000000000046}:0x820d");
+                                $mapiprops[$namedStartTime] = $data;
+                                $namedCommonStart = GetPropIDFromString($this->_store, "PT_SYSTIME:{00062008-0000-0000-C000-000000000046}:0x8516");
+                                $mapiprops[$namedCommonStart] = $data;
+                                $clipStart = GetPropIDFromString($this->_store, "PT_SYSTIME:{00062002-0000-0000-C000-000000000046}:0x8235");
+                                $mapiprops[$clipStart] = $data;
+                                $mapiprops[PR_START_DATE] = $data;
+                                break;
+
+                            case 'DTEND':
+                                $data = $this->getTimestampFromStreamerDate($data);
+                                $namedEndTime = GetPropIDFromString($this->_store, "PT_SYSTIME:{00062002-0000-0000-C000-000000000046}:0x820e");
+                                $mapiprops[$namedEndTime] = $data;
+                                $namedCommonEnd = GetPropIDFromString($this->_store, "PT_SYSTIME:{00062008-0000-0000-C000-000000000046}:0x8517");
+                                $mapiprops[$namedCommonEnd] = $data;
+                                $clipEnd = GetPropIDFromString($this->_store, "PT_SYSTIME:{00062002-0000-0000-C000-000000000046}:0x8236");
+                                $mapiprops[$clipEnd] = $data;
+                                $mapiprops[PR_END_DATE] = $data;
+                                break;
+
+                            case 'UID':
+                                $goid = GetPropIDFromString($this->_store, "PT_BINARY:{6ED8DA90-450B-101B-98DA-00AA003F1305}:0x3");
+                                $goid2 = GetPropIDFromString($this->_store, "PT_BINARY:{6ED8DA90-450B-101B-98DA-00AA003F1305}:0x23");
+                                $mapiprops[$goid] = $mapiprops[$goid2] = hex2bin($data);
+                                break;
+
+                            case 'ATTENDEE':
+                                $fields = explode(";", $field);
+                                foreach ($fields as $field) {
+                                    $prop_pos     = strpos($field, '=');
+                                    if ($prop_pos !== false) {
+                                        switch (substr($field, 0, $prop_pos)) {
+                                            case 'PARTSTAT'    : $partstat = substr($field, $prop_pos+1); break;
+                                            case 'CN'        : $cn = substr($field, $prop_pos+1); break;
+                                            case 'ROLE'        : $role = substr($field, $prop_pos+1); break;
+                                            case 'RSVP'        : $rsvp = substr($field, $prop_pos+1); break;
+                                        }
+                                    }
+                                }
+                                if (isset($partstat) && isset($aClassMap[$partstat]) &&
+
+                                   (!isset($mapiprops[PR_MESSAGE_CLASS]) || $mapiprops[PR_MESSAGE_CLASS] == "IPM.Schedule.Meeting.Request")) {
+                                    $mapiprops[PR_MESSAGE_CLASS] = $aClassMap[$partstat]['class'];
+                                    $mapiprops[PR_ICON_INDEX] = $aClassMap[$partstat]['icon'];
+                                }
+                                // START ADDED dw2412 to support meeting requests on HTC Android Mail App
+                                elseif (isset($role) && isset($aClassMap[$role]) &&
+                                   (!isset($mapiprops[PR_MESSAGE_CLASS]) || $mapiprops[PR_MESSAGE_CLASS] == "IPM.Schedule.Meeting.Request")) {
+                                    $mapiprops[PR_MESSAGE_CLASS] = $aClassMap[$role]['class'];
+                                    $mapiprops[PR_ICON_INDEX] = $aClassMap[$role]['icon'];
+                                }
+                                // END ADDED dw2412 to support meeting requests on HTC Android Mail App
+                                if (!isset($cn)) $cn = ""; 
+                                $data         = str_replace ("MAILTO:", "", $data);
+                                $attendee[] = array ('name' => stripslashes($cn), 'email' => stripslashes($data));
+                                break;
+
+                            case 'ORGANIZER':
+                                $field          = str_replace("ORGANIZER;CN=", "", $field);
+                                $data          = str_replace ("MAILTO:", "", $data);
+                                $organizer[] = array ('name' => stripslashes($field), 'email' => stripslashes($data));
+                                break;
+
+                            case 'LOCATION':
+                                $data = str_replace("\\n", "<br />", $data);
+                                $data = str_replace("\\t", "&nbsp;", $data);
+                                $data = str_replace("\\r", "<br />", $data);
+                                $data = stripslashes($data);
+                                $namedLocation = GetPropIDFromString($this->_store, "PT_STRING8:{00062002-0000-0000-C000-000000000046}:0x8208");
+                                $mapiprops[$namedLocation] = $data;
+                                $tneflocation = GetPropIDFromString($this->_store, "PT_STRING8:{6ED8DA90-450B-101B-98DA-00AA003F1305}:0x2");
+                                $mapiprops[$tneflocation] = $data;
+                                break;
+                        }
+                    }
+                    break;
+            }
+            $i++;
+
+        }
+        $useTNEF = GetPropIDFromString($this->_store, "PT_BOOLEAN:{00062008-0000-0000-C000-000000000046}:0x8582");
+        $mapiprops[$useTNEF] = true;
+    }
+
+    /*
+     * Converts an YYYYMMDDTHHMMSSZ kind of string into an unixtimestamp
+     *
+     * @param string $data
+     * @return long
+     */
+    function getTimestampFromStreamerDate ($data) {
+        $data = str_replace('Z', '', $data);
+        $data = str_replace('T', '', $data);
+
+        preg_match ('/([0-9]{4})([0-9]{2})([0-9]{2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})/', $data, $regs);
+        if ($regs[1] < 1970) {
+            $regs[1] = '1971';
+        }
+        return gmmktime($regs[4], $regs[5], $regs[6], $regs[2], $regs[3], $regs[1]);
+    }
+}
+
+?>
